<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Bootstrap dice</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- font -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Lato"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <style>
      .backgroundimg {
        position: relative;
      }

      .onImg {
        position: absolute;
        top: 0;
      }
    </style>
  </head>

  <body>
    <div class="container-fluid">
      <div class="row backgroundimg">
        <img
          class="background"
          src="./image/ob_cd446b_black-bg-casinodice.jpg"
          alt=""
          width="100%"
          height="auto"
        />
      </div>
      <div class="onImg mr-3">
        <div class="row mt-5">
          <div class="col-sm-5">
            <h3 class="text-white mb-3">Nhập thông tin</h3>
            <form>
              <div class="form-group row">
                <label
                  for="inputPassword"
                  class="col-sm-2 col-form-label text-white"
                  >UserName</label
                >
                <div class="col-sm-10">
                  <input
                    type="text"
                    class="form-control"
                    id="inp-user"
                    placeholder=""
                  />
                </div>
              </div>
              <div class="form-group row">
                <label
                  for="inputPassword"
                  class="col-sm-2 col-form-label text-white"
                  >FirstName</label
                >
                <div class="col-sm-10">
                  <input
                    type="text"
                    class="form-control"
                    id="inp-fname"
                    placeholder=""
                  />
                </div>
              </div>
              <div class="form-group row">
                <label
                  for="inputPassword"
                  class="col-sm-2 col-form-label text-white"
                  >LastName</label
                >
                <div class="col-sm-10">
                  <input
                    type="text"
                    class="form-control"
                    id="inp-lname"
                    placeholder=""
                  />
                </div>
              </div>
            </form>
          </div>
          <div class="col-sm-4 text-center">
            <button class="btn btn-success" onclick="onBtnNemXucXac()">
              Ném #new-dice
            </button>
            <br />
            <img
              id="img-dice"
              class="mt-3"
              src="./image/dice.png"
              alt=""
              width="45%"
            />
            <p id="text-message" class="text-success font-weight-bold">
              Chúc mừng
            </p>
          </div>
          <div class="col-sm-3 text-center text-white">
            <p id="voucher">voucher</p>
            <p id="id-voucher">id</p>
            <p id="phan-tram-giam-gia">Phần trăm</p>
            <img id="present" src="./image/car.jpg" alt="" width="100%" />
          </div>
        </div>

        <div class="row mt-3">
          <div class="col-sm-12 text-center">
            <button class="btn btn-success w-25" onclick="onBtnHistoryDie()">
              Dice history
            </button>
            <button
              class="btn btn-primary w-25"
              onclick="onBtnHistoryVoucher()"
            >
              History voucher
            </button>
            <button class="btn btn-warning w-25">Present voucher</button>
          </div>
        </div>
        <div class="row mt-3">
          <div class="col-sm-12">
            <table id="table-dice" class="table table-hover table-striped">
              <thead>
                <tr class="table-primary">
                  <th># lượt</th>
                  <th>Dice</th>
                </tr>
              </thead>
              <tbody class="table-primary"></tbody>
            </table>
            <!-- table voucher -->
            <table
              style="display: none"
              id="table-voucher"
              class="table table-hover table-striped mt-3"
            >
              <thead>
                <tr class="table-primary">
                  <th>id</th>
                  <th>Phần trăm giảm giá %</th>
                  <th>Ghi chú</th>
                  <th>Ngày tạo</th>
                  <th>Ngày cập nhật</th>
                </tr>
              </thead>
              <tbody class="table-primary"></tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gCOL_COUNT = 0;
    const gCOL_DICE = 1;
    const gCOL_ID = 0;
    const gCOL_PHAN_TRAM_GIAM_GIA = 1;
    const gCOL_GHI_CHU = 2;
    const gCOL_NGAY_CAP_NHAT = 3;
    const gCOL_NGAY_TAO = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    // btn ném xúc xắc
    function onBtnNemXucXac() {
      var vUserObj = {
        userName: "",
        firstName: "",
        lastName: "",
      };
      var vXmlHttp = new XMLHttpRequest();

      thuThapThongTin(vUserObj);
      goiApiDeTungXucXac(vUserObj, vXmlHttp);
      var vCheck = kiemTraThongTin(vUserObj);
      if (kiemTraThongTin) {
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            hienThiXucXac(vXmlHttp);
            hienThiThongTinVoucher(vXmlHttp);
            hienThiQuaTang(vXmlHttp);
          }
        };
      }
    }
    // btn historydice
    function onBtnHistoryDie() {
      var vUserObj = {
        userName: "",
        firstName: "",
        lastName: "",
      };
      var vXmlHttp = new XMLHttpRequest();

      thuThapThongTin(vUserObj);
      goiApiHistoryDice(vUserObj, vXmlHttp);
      var vCheck = kiemTraThongTin(vUserObj);
      if (vCheck) {
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            hienThiHistoryDice(vXmlHttp);
          }
        };
      }
    }
    // btn historyvoucher
    function onBtnHistoryVoucher() {
      var vTableVoucher = document.getElementById("table-voucher");
      vTableVoucher.style.display = "block";
      var vUserObj = {
        userName: "",
        firstName: "",
        lastName: "",
      };

      var vXmlHttp = new XMLHttpRequest();

      thuThapThongTin(vUserObj);
      goiApiHistoryVoucher(vUserObj, vXmlHttp);
      var vCheck = kiemTraThongTin(vUserObj);
      if (vCheck) {
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            hienThiHistoryVoucher(vXmlHttp);
          }
        };
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // ham thu thap thong tin
    function thuThapThongTin(paramUser) {
      var vInpUser = document.getElementById("inp-user");
      var vInpFName = document.getElementById("inp-fname");
      var vInpLName = document.getElementById("inp-lname");

      paramUser.userName = vInpUser.value.trim();
      paramUser.firstName = vInpFName.value.trim();
      paramUser.lastName = vInpLName.value.trim();
    }
    // ham kiem tra thong tin
    function kiemTraThongTin(paramUser) {
      if (
        paramUser.userName == "" ||
        paramUser.firstName == "" ||
        paramUser.lastName == ""
      ) {
        alert("Các trường không được bỏ trống!");
        return false;
      }
      return true;
    }
    // ham goi api tung xuc xac
    function goiApiDeTungXucXac(paramUser, paramXmlHttp) {
      var vDataJson = JSON.stringify(paramUser);
      paramXmlHttp.open("POST", gBASE_URL + "dice", true);
      paramXmlHttp.setRequestHeader(
        "Content-Type",
        gUTF8_TEXT_APPLICATION_HEADER
      );
      paramXmlHttp.send(vDataJson);
    }
    // ham hien thi xuc xac
    function hienThiXucXac(paramXmlHttp) {
      var vObjDice = JSON.parse(paramXmlHttp.responseText);
      var vTextMessage = document.getElementById("text-message");
      var vImgDice = document.getElementById("img-dice");
      if (vObjDice.dice == 1) {
        vImgDice.src = "image/1.png";
        vTextMessage.innerHTML = "Chúc bạn may mắn lần sau";
      } else if (vObjDice.dice == 2) {
        vImgDice.src = "image/2.png";
        vTextMessage.innerHTML = "Chúc bạn may mắn lần sau";
        vTextMessage.className = "text-warning font-weight-bold";
      } else if (vObjDice.dice == 3) {
        vImgDice.src = "image/3.png";
        vTextMessage.innerHTML = "Chúc bạn may mắn lần sau";
        vTextMessage.className = "text-warning font-weight-bold";
      } else if (vObjDice.dice == 4) {
        vImgDice.src = "image/4.png";
        vTextMessage.innerHTML = "Chúc mừng bạn hãy chơi tiếp";
        vTextMessage.className = "text-warning font-weight-bold";
      } else if (vObjDice.dice == 5) {
        vImgDice.src = "image/5.png";
        vTextMessage.innerHTML = "Chúc mừng bạn hãy chơi tiếp";
      } else if (vObjDice.dice == 6) {
        vImgDice.src = "image/6.png";
        vTextMessage.innerHTML = "Chúc mừng bạn hãy chơi tiếp";
      }
    }
    // ham hien thi thong tin voucher
    function hienThiThongTinVoucher(paramXmlHttp) {
      var vTextId = document.getElementById("id-voucher");
      var vTextPhanTramGiamGia = document.getElementById("phan-tram-giam-gia");
      var vTextVoucher = document.getElementById("voucher");

      var vObjVoucher = JSON.parse(paramXmlHttp.responseText);
      if (vObjVoucher.voucher == null) {
        vTextVoucher.innerHTML = "Không có voucher";
      } else {
        vTextVoucher.innerHTML = "Voucher";
        vTextId.innerHTML = vObjVoucher.voucher.id;
        vTextPhanTramGiamGia.innerHTML =
          vObjVoucher.voucher.phanTramGiamGia + "%";
      }
    }
    // ham hien thi qua tang
    function hienThiQuaTang(paramXmlHttp) {
      var vObjPresent = JSON.parse(paramXmlHttp.responseText);
      var vImgPresent = document.getElementById("present");
      if (vObjPresent.prize == null) {
        vImgPresent.src = "image/empty.jpg";
      } else if (vObjPresent.prize == "Mũ") {
        vImgPresent.src = "image/hat.jpg";
      } else if (vObjPresent.prize == "Sổ") {
        vImgPresent.src = "image/book.jpg";
      } else if (vObjPresent.prize == "Bút") {
        vImgPresent.src = "image/but.png";
      } else if (vObjPresent.prize == "Áo mưa") {
        vImgPresent.src = "image/ao-mua.jpg";
      } else if (vObjPresent.prize == "Xe máy") {
        vImgPresent.src = "image/xe-may.jpg";
      }
    }
    // goi api de lay lich su tung xuc xac
    function goiApiHistoryDice(paramUser, paramXmlHttp) {
      paramXmlHttp.open(
        "GET",
        gBASE_URL + "/dice-history?username=" + paramUser.userName,
        true
      );
      paramXmlHttp.send();
    }
    // ha hien thi lich su tung xuc xac
    function hienThiHistoryDice(paramXmlHttp) {
      var vObjHistoryDice = JSON.parse(paramXmlHttp.responseText);
      var vTableDice = document.getElementById("table-dice");
      var vTableBody = vTableDice.getElementsByTagName("tbody")[0];

      for (var bI = 0; bI < vObjHistoryDice.dices.length; bI++) {
        var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
        var vCellCount = vNewRow.insertCell(gCOL_COUNT);
        var vCellDice = vNewRow.insertCell(gCOL_DICE);

        vCellCount.innerHTML = bI + 1;
        vCellDice.innerHTML = vObjHistoryDice.dices[bI];
      }
    }
    function goiApiHistoryVoucher(paramUser, paramXmlHttp) {
      paramXmlHttp.open(
        "GET",
        gBASE_URL + "/voucher-history?username=" + paramUser.userName,
        true
      );
      paramXmlHttp.send();
    }
    // ha hien thi lich su tung xuc xac
    function hienThiHistoryVoucher(paramXmlHttp) {
      var vObjHistoryVoucher = JSON.parse(paramXmlHttp.responseText);
      var vTableVoucher = document.getElementById("table-voucher");
      var vTableBody = vTableVoucher.getElementsByTagName("tbody")[0];

      for (var bI = 0; bI < vObjHistoryVoucher.vouchers.length; bI++) {
        var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
        var vCellId = vNewRow.insertCell(gCOL_ID);
        var vCellPhanTramGiamGia = vNewRow.insertCell(gCOL_PHAN_TRAM_GIAM_GIA);
        var vCellGhiChu = vNewRow.insertCell(gCOL_GHI_CHU);
        var vCellNgayCapNhat = vNewRow.insertCell(gCOL_NGAY_CAP_NHAT);
        var vCellNgayTao = vNewRow.insertCell(gCOL_NGAY_TAO);

        vCellId.innerHTML = vObjHistoryVoucher.vouchers[bI].id;
        vCellPhanTramGiamGia.innerHTML =
          vObjHistoryVoucher.vouchers[bI].phanTramGiamGia;
        vCellGhiChu.innerHTML = vObjHistoryVoucher.vouchers[bI].ghiChu;
        vCellNgayCapNhat.innerHTML =
          vObjHistoryVoucher.vouchers[bI].ngayCapNhat;
        vCellNgayTao.innerHTML = vObjHistoryVoucher.vouchers[bI].ngayTao;
      }
    }
  </script>
</html>
